using System;
using System.Windows.Forms;
using System.Drawing;
using System.Diagnostics;
using System.Threading;
using System.Collections;
using USB_HID;
using Utilitaires;

namespace RBC9___HID
{
    public class RBC9NoForm : ApplicationContext
    {
           
        private System.ComponentModel.IContainer components;						// a list of components to dispose when the context is disposed
        private System.Windows.Forms.NotifyIcon MyNotifyIcon;				// the icon that sits in the system tray
        private System.Windows.Forms.ContextMenu MyNotifyIconContextMenu;	// the context menu for the notify icon
        private System.Windows.Forms.Timer Balloon_Kill_Timer = new System.Windows.Forms.Timer();
        
        private System.Windows.Forms.Form LayoutForm;						// the current form we're displaying
        //private System.Windows.Forms.Form MxForm;


        private SpaceNavigator SpaceNav;
        //private MX1000 MyMx1000 = new MX1000();

        private short LastProfilNum = -999;
        private short DefaultProfilNum = -1;
        private ArrayList AppAutoList = new ArrayList();

        private Thread Thread_AutoSwitch;
        private bool Thread_AutoSwitch_Running;

        private bool InfoBulle;
        private bool LEDEnable;

        private int CurDevice;
        private string CurDevName;

        private bool Balloon_Timer_Flag = false;

        public RBC9NoForm()
        {
            InitializeContext();

            if (!Start_Nav())
            {
                this.MyNotifyIcon.BalloonTipIcon = ToolTipIcon.Warning;
                MyNotifyIcon.BalloonTipText = "! "+CurDevName+" not Found !";
                if (InfoBulle == true)
                {
                    MyNotifyIcon.ShowBalloonTip(1000);
                }
            }

            AutoSwitch_Start();
        }


        private void InitializeContext()
        {
            System.Windows.Forms.MenuItem NewMenuItem;

            this.components = new System.ComponentModel.Container();

            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon0.ico"));
            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon1.ico"));
            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon2.ico"));
            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon3.ico"));
            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon4.ico"));
            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon5.ico"));
            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon6.ico"));
            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon7.ico"));
            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon8.ico"));
            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon9.ico"));
            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon10.ico"));
            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon11.ico"));
            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon12.ico"));
            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon13.ico"));
            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon14.ico"));
            //this.MyIconList.Add(new Icon(typeof(RBC9NoForm), "icon15.ico"));


            this.MyNotifyIcon = new System.Windows.Forms.NotifyIcon(this.components);
            this.MyNotifyIconContextMenu = new System.Windows.Forms.ContextMenu();


            // 
            // NotifyIcon
            // 
            this.MyNotifyIcon.ContextMenu = this.MyNotifyIconContextMenu;
            //this.MyNotifyIcon.MouseClick += new MouseEventHandler(MyNotifyIcon_MouseClick);
            this.MyNotifyIcon.MouseDoubleClick += new MouseEventHandler(MyNotifyIcon_MouseDoubleClick);
            this.MyNotifyIcon.BalloonTipShown += new EventHandler(MyNotifyIcon_BalloonTipShown);
            this.Balloon_Kill_Timer.Tick += new EventHandler(TimerEventProcessor);

            this.MyNotifyIcon.Icon = new Icon(typeof(RBC9NoForm), "icon0.ico");
                //(Icon)MyIconList[0];

            this.MyNotifyIcon.Text = "RBC9 - SpaceDevice";
            this.MyNotifyIcon.BalloonTipTitle = this.MyNotifyIcon.Text;
            this.MyNotifyIcon.BalloonTipIcon = ToolTipIcon.Info;
            MyNotifyIcon.BalloonTipText = "! Wait For " + CurDevName+" ... !";

            this.MyNotifyIcon.Visible = true;

            // 
            // NotifyIconContextMenu
            // 

            MyNotifyIconContextMenu.MenuItems.Clear();

          
            //}
            // 
            // AutoSwitch
            // 
            NewMenuItem = new MenuItem();
            NewMenuItem.Text = "Auto Switch";
            NewMenuItem.Name = "NavAutoSwitch";
            NewMenuItem.Click += new System.EventHandler(this.autoContextMenuItem_Click);
            MyNotifyIconContextMenu.MenuItems.Add(NewMenuItem);
            // 
            // LayoutContextMenuItem
            // 
            NewMenuItem = new MenuItem();
            NewMenuItem.Text = "Edit Layout";
            NewMenuItem.Name = "LayoutForm";
            NewMenuItem.DefaultItem = true;
            NewMenuItem.Click += new System.EventHandler(this.showContextMenuItem_Click);
            MyNotifyIconContextMenu.MenuItems.Add(NewMenuItem);

            NewMenuItem = new MenuItem();
            NewMenuItem.Text = "-";
            MyNotifyIconContextMenu.MenuItems.Add(NewMenuItem);

            // 
            // exitContextMenuItem
            // 
            NewMenuItem = new MenuItem();
            NewMenuItem.Text = "&Exit";
            NewMenuItem.Name = "Exit";
            NewMenuItem.Click += new System.EventHandler(this.exitContextMenuItem_Click);
            MyNotifyIconContextMenu.MenuItems.Add(NewMenuItem);


            LoadLayout();

        }

        private bool Start_Nav()
        {
            SpaceNav = null;
            SpaceNav = SpaceNavigator.FindSpaceNav(CurDevice, 1);
            if (SpaceNav != null)
            {


                LastProfilNum = -999;
                SpaceNav.OnButtonChanged += new HIDChangedEventHandler(SpaceNav_OnButtonChanged);
                SpaceNav.OnDeviceRemoved += new HIDChangedEventHandler(SpaceNav_OnDeviceRemoved);
                SpaceNav.GetNavReport();
                SpaceNav.SetLed(LEDEnable);
               

                return true;
            }
            
            return false;
        }
    
        private void AutoSwitch_Start()
        {
            AutoSwitch_Stop();
            Thread_AutoSwitch_Running = true;
            Thread_AutoSwitch = new Thread(new ThreadStart(AutoSwitch_CheckAppli));
            Thread_AutoSwitch.Start();

        }
        private void AutoSwitch_Stop()
        {
            Thread_AutoSwitch_Running = false;
            if (Thread_AutoSwitch != null)
            {
                Thread_AutoSwitch.Abort();
                while (Thread_AutoSwitch.IsAlive)
                {
                    Thread.Sleep(500);
                }
            }
            Thread_AutoSwitch = null;
        }
        private void AutoSwitch_CheckAppli()
        {
            string FocusApp;
            short[] NewProfilNum;
            NewProfilNum = new short[5];
            int Profil_Count=0;
            bool Multi_Profile_Match = false;

            DateTime Last_StartNav = DateTime.Now;

            while (Thread_AutoSwitch_Running)
            {

                Thread.Sleep(750); // ?? plus court ??



                if (SpaceNav == null)
                {
                    if (((TimeSpan)(DateTime.Now - Last_StartNav)).TotalMilliseconds > 5000)
                    {
                        Last_StartNav = DateTime.Now;
                        Start_Nav();
                    }
                }



                if ((SpaceNav != null)
                    && (MyNotifyIconContextMenu.MenuItems["NavAutoSwitch"].Checked))
                {
                    //Disable LED here
                    //SpaceNav.SetLed(false);

                    NewProfilNum[0] = DefaultProfilNum;
                    
                    FocusApp = User32.GetForegroundApp();

                    if (FocusApp == null) continue;
                    //Debug.Write(FocusApp);
                    //Debug.Write("  ");

                    Profil_Count = 0;

                    foreach (BaseLst NewApp in AppAutoList)
                    {
                        if (NewApp.Txt.ToUpper().Equals(FocusApp))
                        { 
                            NewProfilNum[Profil_Count] = (short)NewApp.Id;
                            Profil_Count++; 
                            //if (Profil_Count > 
                            //break;
                        }
                    }

                    Debug.Write("Profile_Count=");
                    Debug.WriteLine(Profil_Count);


                    Multi_Profile_Match = false;

                    for (int i = 0; i < Profil_Count; i++)
                    {
                        if (NewProfilNum[i] == LastProfilNum)
                        {
                            Multi_Profile_Match = true;
                        }
                    }

                    if (!Multi_Profile_Match && NewProfilNum[0] != LastProfilNum)
                    {
                        SpaceNav.SelectProfil(NewProfilNum[0]);
                    }

                    //Debug.Write("New#1=");
                    //Debug.Write(NewProfilNum[0]);
                    //Debug.Write("  New#2=");
                    //Debug.Write(NewProfilNum[1]);
                    //Debug.Write("  Match=");
                    //Debug.Write(Multi_Profile_Match);
                    //Debug.Write("  Last=");
                    //Debug.WriteLine(LastProfilNum);
                    

                }
            }

        }


        void MyNotifyIcon_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            //MyNotifyIcon.ShowBalloonTip(1000);
            //SpaceNav.SetLed(false);
            ShowForm();
           
        }

       private void MyNotifyIcon_BalloonTipShown(Object sender, EventArgs e)
       {
           Balloon_Kill_Timer.Interval = 1500;
           Balloon_Kill_Timer.Start();
           
           while (!Balloon_Timer_Flag)
           {
               Application.DoEvents();
           }
           
           //Kill balloons
           if (MyNotifyIcon.Visible == true && Balloon_Timer_Flag == true)
           {
               MyNotifyIcon.Visible = false;
               MyNotifyIcon.Visible = true;
               Balloon_Timer_Flag = false;
           }
       }

        private void TimerEventProcessor(Object myObject, EventArgs myEventArgs)
        {
            Balloon_Kill_Timer.Stop();
            Balloon_Timer_Flag = true;
        }


        private void LoadLayout()
        {
            LayoutList SwitchLayout = new LayoutList();

            System.Windows.Forms.MenuItem NewMenuItem;
            System.Windows.Forms.MenuItem NewSubMenuItem;

            SwitchLayout.LoadLayout(false);
            AppAutoList.Clear();
            foreach (LayoutStruct MyLayout in SwitchLayout._Layout)
            {
                foreach (BaseLst NewAppList in MyLayout._AppAuto)
                {
                    AppAutoList.Add(NewAppList);
                }
            }
            DefaultProfilNum = SwitchLayout.Default_Profil;
            LastProfilNum = SwitchLayout.Last_Profil;
            //Debug.WriteLine(DefaultProfilNum);

            
            MyNotifyIconContextMenu.MenuItems.RemoveByKey("SwitchLayout");

            // 
            // SwitchContextMenuItem
            // 
            NewMenuItem = new MenuItem();
            NewMenuItem.Text = "Switch Layout";
            NewMenuItem.Name = "SwitchLayout";
            MyNotifyIconContextMenu.MenuItems.Add(NewMenuItem);
            NewMenuItem.Index = 2;
            //if (MyMx1000.SetPointOk)
            //{
            //    NewMenuItem.Index = 5;
            //}
            //else
            //{
            //    NewMenuItem.Index = 2;
            //}

            foreach (LayoutStruct MyLayout in SwitchLayout._Layout)
            {
                NewSubMenuItem = new MenuItem();
                NewSubMenuItem.Text = MyLayout.Profil_Name;
                if (SwitchLayout.Default_Profil == MyLayout.Profil_Id)
                {
                    NewSubMenuItem.DefaultItem = true;
                }
                NewSubMenuItem.Tag = MyLayout.Profil_Id.ToString();
                NewSubMenuItem.Name = MyLayout.Profil_Id.ToString();
                NewSubMenuItem.Click += new System.EventHandler(this.SwitchMenuItem_Click);
                NewSubMenuItem.RadioCheck = true;

                NewMenuItem.MenuItems.Add(NewSubMenuItem);
            }

            MyNotifyIconContextMenu.MenuItems["NavAutoSwitch"].Checked = SwitchLayout.AutoSwitch;

            InfoBulle = SwitchLayout.InfoBulle;
            LEDEnable = SwitchLayout.LEDEnable;

            //Debug.WriteLine(LEDEnable);
            //SwitchLayout.LEDEnable = LEDEnable;
            //Debug.WriteLine(SwitchLayout.LEDEnable);
            //if (MainNav != null) MainNav.
            //SpaceNav.SetLed(SwitchLayout.LEDEnable);
            
            CurDevice = SwitchLayout.DeviceId;
            CurDevName = MyConst.MyTxt_ById(MyConst.MyDevice_Txt, CurDevice);
        }


        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
        }

        private void showContextMenuItem_Click(object sender, EventArgs e)
        {
            MenuItem MyMenu = (MenuItem)sender;

            ShowForm();

        }

        private void autoContextMenuItem_Click(object sender, EventArgs e)
        {
            MenuItem MyMenu = (MenuItem)sender;

            MyMenu.Checked = !MyMenu.Checked;

        }

        private void SwitchMenuItem_Click(object sender, EventArgs e)
        {
            MenuItem MyMenu = (MenuItem)sender;
            if (MyNotifyIconContextMenu.MenuItems["NavAutoSwitch"].Checked)
            {
                if (MessageBox.Show(
               "AutoSwitch is on - Turn Off AutoSwitch ?",
               "AutoSwitch",
               MessageBoxButtons.YesNo)
               == DialogResult.Yes)
                {
                    MyNotifyIconContextMenu.MenuItems["NavAutoSwitch"].Checked = false;

                }
            }


            if (SpaceNav != null)
            {
                //Debug.WriteLine(short.Parse(MyMenu.Tag.ToString()));
                SpaceNav.SelectProfil(short.Parse(MyMenu.Tag.ToString()));
            }

        }

        private void exitContextMenuItem_Click(object sender, EventArgs e)
        {

            ExitThread();
        }

        private void ShowForm()
        {

            if (LayoutForm == null)
            {
                LayoutForm = new RBC9SpaceNav(ref SpaceNav);
                LayoutForm.Show();
                LayoutForm.Closed += new EventHandler(mainForm_Closed);
            }
            else
            {
                LayoutForm.Activate();
            }

        }


        private void mainForm_Closed(object sender, EventArgs e)
        {
            Form MyForm = (Form)sender;

            if (MyForm.Equals(this.LayoutForm))
            {
                this.LayoutForm = null;
                LastProfilNum = -999;
                LoadLayout();

                if (SpaceNav != null)
                {
                    if (SpaceNav.nPid != CurDevice)
                    {
                        if (!Start_Nav())
                        {
                            this.MyNotifyIcon.BalloonTipIcon = ToolTipIcon.Warning;
                            MyNotifyIcon.BalloonTipText = "! " + CurDevName + " not Found !";
                            if (InfoBulle == true)
                            {
                                MyNotifyIcon.ShowBalloonTip(1500);
                            }
                        }
                    }
                    //if (SpaceNav != null)
                    SpaceNav.GetNavReport();
                    SpaceNav.SetLed(LEDEnable);
                    
                    User32.MinimizeFootprint();
                }


            }

        }

        protected override void ExitThreadCore()
        {
            AutoSwitch_Stop();

            if (LayoutForm != null) LayoutForm.Close();
            
            if (SpaceNav != null)
            {
                SpaceNav.OnButtonChanged -= SpaceNav_OnButtonChanged;
                SpaceNav.OnDeviceRemoved -= SpaceNav_OnDeviceRemoved;
                SpaceNav = null;
            }

            base.ExitThreadCore();
        }


        void SpaceNav_UpdateProfil(short ProfilNum)
        {
            if (ProfilNum != LastProfilNum)
            {
                this.MyNotifyIcon.BalloonTipIcon = ToolTipIcon.Info;
                MyNotifyIcon.BalloonTipText = "! Hardcoded Layout !";

                MenuItem MySwitch = MyNotifyIconContextMenu.MenuItems["SwitchLayout"];
                foreach (MenuItem OldLayout in MySwitch.MenuItems)
                {
                    OldLayout.Checked = false;
                }

                MenuItem MyLayout = MySwitch.MenuItems[ProfilNum.ToString()];
                if (MyLayout != null)
                {
                    MyNotifyIcon.BalloonTipText = "< " + MyLayout.Text.ToString() + " >";
                    MyLayout.Checked = true;
                    //Thread.Sleep( 2000);
                    //if (InfoBulle == true)
                    //{
                    //    MyNotifyIcon.ShowBalloonTip(1000);
                    //}
                }


                LastProfilNum = ProfilNum;
            }



        }

        void SpaceNav_OnButtonChanged(object sender, HIDChangedEventArgs args)
        {
            

            if (args.HIDValue.IsRBC9Present)
            {
                SpaceNav_UpdateProfil(args.HIDValue.ProfilNum);
            }
            else
            {
                this.MyNotifyIcon.BalloonTipIcon = ToolTipIcon.Error;
                MyNotifyIcon.BalloonTipText = "! RBC9 SpaceDevice driver Not Installed !";
                if (InfoBulle == true)
                {
                    MyNotifyIcon.ShowBalloonTip(2000);
                }

            }

        }

        void SpaceNav_OnDeviceRemoved(object sender, HIDChangedEventArgs args)
        {
            Debug.WriteLine("Device Remove  ");
            SpaceNav = null;
            this.MyNotifyIcon.BalloonTipIcon = ToolTipIcon.Warning;
            MyNotifyIcon.BalloonTipText = "! Device Removed !";
            if (InfoBulle == true)
            {
                MyNotifyIcon.ShowBalloonTip(3000);
            }
            Thread.Sleep(3000);
            this.MyNotifyIcon.BalloonTipIcon = ToolTipIcon.Info;
            MyNotifyIcon.BalloonTipText = "! Wait For "+CurDevName + " ... !";
            if (InfoBulle == true)
            {
                MyNotifyIcon.ShowBalloonTip(1000);
            }
        
        }

    }
}
